// ContextApplicationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ContextApplication.h"
#include "ContextApplicationDlg.h"
#include <shlwapi.h> 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContextApplicationDlg dialog

CContextApplicationDlg::CContextApplicationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CContextApplicationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CContextApplicationDlg)
	appPath = _T("");
	iconLocation = _T("");
	contextName = _T("");
	//}}AFX_DATA_INIT
	iconPath = _T("");
	iconIndex = 0;
	oldKey = _T("");
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CContextApplicationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CContextApplicationDlg)
	DDX_Control(pDX, IDC_STATIC_Icon, iconStatic);
	DDX_Text(pDX, IDC_EDIT_AppPath, appPath);
	DDX_Text(pDX, IDC_EDIT_Icon, iconLocation);
	DDX_Text(pDX, IDC_EDIT_NAME, contextName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CContextApplicationDlg, CDialog)
	//{{AFX_MSG_MAP(CContextApplicationDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_PickApp, OnButtonPickApp)
	ON_BN_CLICKED(IDC_BUTTON_PickIcon, OnButtonPickIcon)
	ON_BN_CLICKED(ID_About, OnAbout)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_UNDO, OnButtonUndo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContextApplicationDlg message handlers

BOOL CContextApplicationDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	GetDlgItem(IDC_BUTTON_ADD)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_UNDO)->EnableWindow(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CContextApplicationDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CContextApplicationDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CContextApplicationDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CContextApplicationDlg::OnButtonPickApp() 
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE, _T(".exe"), NULL, OFN_ENABLESIZING|OFN_HIDEREADONLY , 
		_T("ִļ (*.exe)|*.exe||"), NULL);
	// using the Xp style
	dlg.m_ofn.lStructSize = 88; 
	// changing the dialog's title
	dlg.m_ofn.lpstrTitle = _T("ѡӦó");
	if(dlg.DoModal() == IDOK)
	{
		appPath = dlg.GetPathName();
		GetDlgItem(IDC_BUTTON_ADD)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_AppPath)->SetWindowText(appPath);
	}
}

void CContextApplicationDlg::OnButtonPickIcon() 
{
	// TODO: Add your control notification handler code here
	typedef BOOL (__stdcall * pFuncPickIconDlg)(HWND, LPWSTR, DWORD, LPDWORD );	
    HINSTANCE hDll = NULL;
	pFuncPickIconDlg p =NULL;
    hDll = LoadLibrary(_T("Shell32.dll"));
	if(!hDll)
	{
		MessageBox(_T("Can't find file \"Shell32.dll\""), _T("Error!"), MB_ICONSTOP);
		return;
	}
    p = (pFuncPickIconDlg)GetProcAddress(hDll, MAKEINTRESOURCEA(62));
    TCHAR path[256];
	DWORD index;
	memset(path,0,256*sizeof(wchar_t));
	if(p(m_hWnd, path, 256, &index))
	{
		iconPath = path;
		iconIndex = index;
		iconLocation.Format(_T("%s,%d"), iconPath, iconIndex);

		
		LONG style = GetWindowLong(iconStatic.GetSafeHwnd(), GWL_STYLE);
		style |= SS_ICON; 
		style |= SS_CENTERIMAGE;  
		SetWindowLong(iconStatic.GetSafeHwnd(),GWL_STYLE,style);
		HICON hIcon = ExtractIcon(AfxGetApp()->m_hInstance, path, iconIndex);
		if(hIcon)
		{
			iconStatic.SetIcon(hIcon);
			DestroyIcon(hIcon);
		}
		GetDlgItem(IDC_EDIT_Icon)->SetWindowText(iconLocation);
	}
	FreeLibrary(hDll);
}

void CContextApplicationDlg::OnAbout() 
{
	// TODO: Add your control notification handler code here
	CAboutDlg dlg;
	dlg.DoModal();
}

void CContextApplicationDlg::OnButtonAdd() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	contextName.TrimLeft();
	contextName.TrimRight();
	UpdateData(FALSE);
	if(contextName.IsEmpty())
	{
		MessageBox(_T("дһ˵ƣΪգ"), 
			_T("˵Ϊգ"), MB_ICONSTOP);
		return;
	}
	
	CString addKey;
	addKey.Format(_T("*\\shell\\%s"),contextName);

	TCHAR iconKeyBuffer[256];
	size_t iconKeyBufferSize = _stprintf(iconKeyBuffer,_T("\"%s\",%d"),(LPCTSTR)iconPath, iconIndex);

	HKEY hKey;
	if(RegCreateKey(HKEY_CLASSES_ROOT, addKey, &hKey))
	{
		MessageBox(_T("ûйԱȨޣ߲˵ƷǷ"),
			_T("ע"),MB_ICONSTOP);
		return;
	}
	RegSetValue(hKey, NULL, REG_SZ, contextName, contextName.GetLength());
	if(!iconPath.IsEmpty())
	{
		RegSetValueEx(hKey, _T("Icon"), 0, REG_SZ, 
		(LPBYTE)iconKeyBuffer, (iconKeyBufferSize+1)*sizeof(TCHAR));
	}	

	CString addCmdKey = addKey+_T("\\command");
	RegCreateKey(HKEY_CLASSES_ROOT, addCmdKey, &hKey);
	CString cmdKey;
	cmdKey.Format(_T("\"%s\" \"%%1\""),appPath);
	RegSetValue(hKey, NULL, REG_SZ, cmdKey, cmdKey.GetLength());

	RegCloseKey(hKey);
	
	oldKey = addKey;
	contextName.Empty();
	UpdateData(FALSE);
	GetDlgItem(IDC_BUTTON_UNDO)->EnableWindow(TRUE);
}

void CContextApplicationDlg::OnButtonUndo() 
{
	// TODO: Add your control notification handler code here

	if(!oldKey.IsEmpty())
	{
		if(SHDeleteKey(HKEY_CLASSES_ROOT, oldKey))
		{
			MessageBox(_T("ɾֵʧܣ"), _T("Error!"), MB_ICONSTOP);
		}
		oldKey.Empty();
	}
	GetDlgItem(IDC_BUTTON_UNDO)->EnableWindow(FALSE);
}
